// this object works with one of the non-leading players
object ".FTL.Slave2"
{
    requires 0.2.0
    hide_unless_in_editor_mode
    always_active

    // -------------------------------------------------------
    // Character selector
    // -------------------------------------------------------
    state "main"
    {
        hide
    }

    state "destroy"
    {
        destroy
    }

    state "Surge"
    {
        observe_player "Surge"
        change_state "Cooldown"
    }

    state "Neon"
    {
        observe_player "Neon"
        change_state "Cooldown"
    }

    state "Charge"
    {
        observe_player "Charge"
        change_state "Cooldown"
    }

    state "Cooldown"
    {
        if "$_ftl_timer >= 0.5" "Start AI"
    }

    // -------------------------------------------------------
    // Simple Artificial Intelligence
    // -------------------------------------------------------
    state "Start AI"
    {
        attach_to_player 0 0

        let "$HBORDER = 290"
        let "$VBORDER = 230"
        let "$walk_right_timer = 0"
        let "$walk_left_timer = 0"

        if "player_xpos() < $_ftl_master_xpos - $HBORDER" "Teleport ->"
        if "player_xpos() > $_ftl_master_xpos + $HBORDER" "Teleport <-"
        if "(player_ypos() < $_ftl_master_ypos - $VBORDER) or (player_ypos() > $_ftl_master_ypos + $VBORDER)" "Teleport v"
        if "player_xpos() < $_ftl_master_xpos - 40" "Walk right"
        if "player_xpos() >= $_ftl_master_xpos + 40" "Walk left"
        if "(player_ypos() > $_ftl_master_ypos + 30) and (random(10) == 0)" "Jump"
    }

    state "Teleport ->"
    {
        set_absolute_position "$_ftl_master_xpos-($HBORDER*0.90)" "$_ftl_master_ypos"
        set_player_position 0 0
        set_player_xspeed "600 + random(150)"
        change_state "Walk right"
    }

    state "Teleport <-"
    {
        set_absolute_position "$_ftl_master_xpos+($HBORDER*0.90)" "$_ftl_master_ypos"
        set_player_position 0 0
        set_player_xspeed "-600 - random(150)"
        change_state "Walk left"
    }

    state "Teleport v"
    {
        //on_random_event 0.1 "Teleport ->"
        //on_random_event 0.1 "Teleport <-"
        set_absolute_position "$_ftl_master_xpos-50+random(100)" "$_ftl_master_ypos-($VBORDER*0.9)"
        set_player_position 0 0
        set_player_xspeed 0
        change_state "Start AI"
    }

    state "Walk right"
    {
        simulate_button_down "right"
        unless "player_xpos() < $_ftl_master_xpos - 40" "Start AI"
        if "(player_ypos() < $_ftl_master_ypos - $VBORDER) or (player_ypos() > $_ftl_master_ypos + $VBORDER)" "Teleport v"
        if "player_xpos() < $_ftl_master_xpos - $HBORDER" "Teleport ->"
        if "(player_ypos() > $_ftl_master_ypos + 30) and (random(10) == 0)" "Jump"
        if "($walk_right_timer += dt()) >= 5" "Deadlock"
    }

    state "Walk left"
    {
        simulate_button_down "left"
        unless "player_xpos() > $_ftl_master_xpos + 40" "Start AI"
        if "(player_ypos() < $_ftl_master_ypos - $VBORDER) or (player_ypos() > $_ftl_master_ypos + $VBORDER)" "Teleport v"
        if "player_xpos() > $_ftl_master_xpos + $HBORDER" "Teleport <-"
        if "(player_ypos() > $_ftl_master_ypos + 30) and (random(10) == 0)" "Jump"
        if "($walk_left_timer += dt()) >= 5" "Deadlock"
    }

    state "Jump"
    {
        let "$jump_cooldown = cond((($jump_cooldown -= dt()) < 0), 2, $jump_cooldown)"
        if "$jump_cooldown < 2" "Start AI"
        change_state "Really Jump"
    }

    state "Really Jump"
    {
        simulate_button_down "fire1"
        simulate_button_down "up"
        on_timeout "0.2" "Start AI"
    }

    state "Deadlock"
    {
        if "abs(player_xpos() - $_ftl_master_xpos) > 200" "Teleport v"
        change_state "Start AI"
    }

    // -------------------------------------------------------
    // Charge and roll
    // -------------------------------------------------------
    state "Charge up"
    {
        attach_to_player 0 0
        set_player_xspeed "$_ftl_player_direction"
        let "$delay = 0.1 + random(5)*0.1"
        if "$_ftl_player_direction > 0" "Charge up: look right"
        change_state "Charge up: look left"
    }

    state "Charge up: look right"
    {
        simulate_button_down "right"
        change_state "Charge up 1"
    }

    state "Charge up: look left"
    {
        simulate_button_down "left"
        change_state "Charge up 1"
    }

    state "Charge up 1"
    {
        on_timeout "$delay" "Charge up 2"
    }

    state "Charge up 2"
    {
        set_player_xspeed 0
        simulate_button_down "down"
        on_timeout "$delay" "Charge up 3"
    }

    state "Charge up 3"
    {
        simulate_button_down "down"
        simulate_button_down "fire1"
    }

    state "Roll"
    {
        simulate_button_down "down"
        on_timeout "0.1 + random(4)*0.1" "Sleep"
    }

    state "Sleep"
    {
        on_timeout 1.5 "Start AI"
    }
}
